#define PAGE_UP   'B'
#define PAGE_DOWN 'F'

class tstring
{
public:
  int  end,x_pos,y_pos,str_len,dis_len,rp,dp;
  char *edit_str;

  tstring(char y,char x,char *str,int slen,int dlen);
  void redraw(void);
  void dec_dp(void);
  void inc_dp(void);
  void run(void);
};

class tobj
{
public:
  virtual void create(tobj *obj);
  virtual void dest(void);
  virtual void redraw(void);
};

class tllist
{
public:
  void       *curr;
  tllist     *next;
  tllist     *curr_ptr;

  tllist(void);
  virtual ~tllist(void);
  virtual void append(void *data,int size);
  void rn(tllist *o,int index);
  virtual void remove_node(int index);
  void restart(void);
  int read_next(void **p);
  int get_ls(tllist *o,int n);
  int get_list_size(void);
};

class tllist_obj
{
public:
  tobj       *curr;
  tllist_obj *next;
  tllist_obj *curr_ptr;

  tllist_obj(void);
  ~tllist_obj(void); 
  void append(tobj *obj); 
  void r(tllist_obj *o);
  void remove(void);
  void restart(void);
  int read_next(tobj **p);
};

class tllist_str : public tllist
{
public:
  void append(char *str);
  void get_str(int index,int offs,char **src);
  void ammend_str(int index,int offs,char *src);
};

class tdialog : public tobj
{
public:
  char *title;
  int  running,touched,size_x,size_y,pos_x,pos_y,cpair;
  
  tdialog(void);
  void create(char *t,int sy,int sx,int py,int px,int c);
  void redraw(void);
};

class tnotify : public tdialog
{
public:
  char *contents;

  void create(char *name,char *cont);
  void redraw(void);
  virtual int run(void);
};

class tquit : public tnotify
{
public:
  int run(void);
};

class tscroll_select : public tllist_str
{
public:
  int pos_x,pos_y,length,pos,hl,hl_bar_size,list_size,scroll_bar_f;
    
  void append(char *str);
  void remove_node(void);
  void init(int y,int x,int l,int hlbs,int sbf);
  void redraw(void);
  void cursor_up(void);
  void cursor_down(void);
  void page_up(void);
  void page_down(void);
  void goto_end(void);
  int get_option(void);
  int get_integer(int o);
  float get_float(int o);
  int get_min_sec(int o);
  int get_hr_min(int o);
  void get_string(char *str,int o,int slen,int dlen);
  int goto_user(char *user);
};

class tstrbox : public tdialog
{
  int str_len,dstr_len;
    
public:
  tstrbox(void);
  int create(char *title,int sy,int sx,int py,int px,int sl);
  void run(char *key_str);
};
